Loading...
Searching...
No Matches
ClpNetworkMatrix Class Reference

This implements a simple network matrix as derived from ClpMatrixBase. More...

`#include <ClpNetworkMatrix.hpp>`

Inheritance diagram for ClpNetworkMatrix:
[legend]
Collaboration diagram for ClpNetworkMatrix:
[legend]

## Public Member Functions

Useful methods
virtual CoinPackedMatrix * | getPackedMatrix () const
| Return a complete CoinPackedMatrix.
virtual bool | isColOrdered () const
| Whether the packed matrix is column major ordered or not.
virtual CoinBigIndex | getNumElements () const
| Number of entries in the packed matrix.
virtual int | getNumCols () const
| Number of columns.
virtual int | getNumRows () const
| Number of rows.
virtual const double * | getElements () const
| A vector containing the elements in the packed matrix.
virtual const int * | getIndices () const
| A vector containing the minor indices of the elements in the packed matrix.
virtual const CoinBigIndex * | getVectorStarts () const
virtual const int * | getVectorLengths () const
| The lengths of the major-dimension vectors.
virtual void | deleteCols (const int numDel, const int *indDel)
| Delete the columns whose indices are listed in `indDel`.
virtual void | deleteRows (const int numDel, const int *indDel)
| Delete the rows whose indices are listed in `indDel`.
virtual void | appendCols (int number, const CoinPackedVectorBase *const *columns)
| Append Columns.
virtual void | appendRows (int number, const CoinPackedVectorBase *const *rows)
| Append Rows.
virtual int | appendMatrix (int number, int type, const CoinBigIndex *starts, const int *index, const double *element, int numberOther=-1)
| Append a set of rows/columns to the end of the matrix.
virtual ClpMatrixBase * | reverseOrderedCopy () const
| Returns a new matrix in reverse order without gaps.
virtual int | countBasis (const int *whichColumn, int &numberColumnBasic)
| Returns number of elements in column part of basis.
virtual void | fillBasis (ClpSimplex *model, const int *whichColumn, int &numberColumnBasic, int *row, int *start, int *rowCount, int *columnCount, CoinFactorizationDouble *element)
| Fills in column part of basis.
virtual CoinBigIndex * | dubiousWeights (const ClpSimplex *model, int *inputWeights) const
| Given positive integer weights for each row fills in sum of weights for each column (and slack).
virtual void | rangeOfElements (double &smallestNegative, double &largestNegative, double &smallestPositive, double &largestPositive)
| Returns largest and smallest elements of both signs.
virtual void | unpack (const ClpSimplex *model, CoinIndexedVector *rowArray, int column) const
| Unpacks a column into an CoinIndexedvector.
virtual void | unpackPacked (ClpSimplex *model, CoinIndexedVector *rowArray, int column) const
| Unpacks a column into an CoinIndexedvector in packed format Note that model is NOT const.
virtual void | add (const ClpSimplex *model, CoinIndexedVector *rowArray, int column, double multiplier) const
| Adds multiple of a column into an CoinIndexedvector You can use quickAdd to add to vector.
virtual void | add (const ClpSimplex *model, double *array, int column, double multiplier) const
| Adds multiple of a column into an array.
virtual void | releasePackedMatrix () const
| Allow any parts of a created CoinMatrix to be deleted.
virtual bool | canDoPartialPricing () const
| Says whether it can do partial pricing.
virtual void | partialPricing (ClpSimplex *model, double start, double end, int &bestSequence, int &numberWanted)
| Partial pricing.
Matrix times vector methods
virtual void | times (double scalar, const double *x, double *y) const
| Return `y + A * scalar *x` in `y`.
virtual void | times (double scalar, const double *x, double *y, const double *rowScale, const double *columnScale) const
| And for scaling.
virtual void | transposeTimes (double scalar, const double *x, double *y) const
| Return `y + x * scalar * A` in `y`.
virtual void | transposeTimes (double scalar, const double *x, double *y, const double *rowScale, const double *columnScale, double *spare=NULL) const
| And for scaling.
virtual void | transposeTimes (const ClpSimplex *model, double scalar, const CoinIndexedVector *x, CoinIndexedVector *y, CoinIndexedVector *z) const
| Return `x * scalar * A + y` in `z`.
virtual void | subsetTransposeTimes (const ClpSimplex *model, const CoinIndexedVector *x, const CoinIndexedVector *y, CoinIndexedVector *z) const
| Return `x *A` in `z` but just for indices in y.
Other
bool | trueNetwork () const
| Return true if really network, false if has slacks.
Constructors, destructor
| ClpNetworkMatrix ()
| Default constructor.
| ClpNetworkMatrix (int numberColumns, const int *head, const int *tail)
| Constructor from two arrays.
virtual | ~ClpNetworkMatrix ()
| Destructor.
Copy method
| ClpNetworkMatrix (const ClpNetworkMatrix &)
| The copy constructor.
| ClpNetworkMatrix (const CoinPackedMatrix &)
| The copy constructor from an CoinNetworkMatrix.
ClpNetworkMatrix & | operator= (const ClpNetworkMatrix &)
virtual ClpMatrixBase * | clone () const
| Clone.
| ClpNetworkMatrix (const ClpNetworkMatrix &wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns)
| Subset constructor (without gaps).
virtual ClpMatrixBase * | subsetClone (int numberRows, const int *whichRows, int numberColumns, const int *whichColumns) const
| Subset clone (without gaps).
Public Member Functions inherited from ClpMatrixBase
virtual int | getVectorLength (int index) const
| The length of a single major-dimension vector.
virtual void | modifyCoefficient (int row, int column, double newElement, bool keepZero=false)
| Modify one element of packed matrix.
virtual int | scale (ClpModel *, ClpSimplex *=NULL) const
| Creates scales for column copy (rowCopy in model may be modified) default does not allow scaling returns non-zero if no scaling done.
virtual void | scaleRowCopy (ClpModel *) const
| Scales rowCopy if column copy scaled Only called if scales already exist.
virtual bool | canGetRowCopy () const
| Returns true if can create row copy.
virtual ClpMatrixBase * | scaledColumnCopy (ClpModel *) const
| Realy really scales column copy Only called if scales already exist.
virtual bool | allElementsInRange (ClpModel *, double, double, int=15)
| Checks if all elements are in valid range.
virtual void | setDimensions (int numrows, int numcols)
| Set the dimensions of the matrix.
virtual int | refresh (ClpSimplex *)
| Purely for column generation and similar ideas.
virtual void | reallyScale (const double *rowScale, const double *columnScale)
virtual int | hiddenRows () const
| Returns number of hidden rows e.g. gub.
virtual int | extendUpdated (ClpSimplex *model, CoinIndexedVector *update, int mode)
| expands an updated column to allow for extra rows which the main solver does not know about and returns number added.
virtual void | primalExpanded (ClpSimplex *model, int mode)
| utility primal function for dealing with dynamic constraints mode=0 - Set up before "update" and "times" for primal solution using extended rows mode=1 - Cleanup primal solution after "times" using extended rows.
virtual void | dualExpanded (ClpSimplex *model, CoinIndexedVector *array, double *other, int mode)
| utility dual function for dealing with dynamic constraints mode=0 - Set up before "updateTranspose" and "transposeTimes" for duals using extended updates array (and may use other if dual values pass) mode=1 - Update dual solution after "transposeTimes" using extended rows.
virtual int | generalExpanded (ClpSimplex *model, int mode, int &number)

general utility function for dealing with dynamic constraints mode=0 - Create list of non-key basics in pivotVariable_ using number as numberBasic in and out mode=1 - Set all key variables as basic mode=2 - return number extra rows needed, number gives maximum number basic mode=3 - before replaceColumn mode=4 - return 1 if can do primal, 2 if dual, 3 if both mode=5 - save any status stuff (when in good state) mode=6 - restore status stuff mode=7 - flag given variable (normally sequenceIn) mode=8 - unflag all variables mode=9 - synchronize costs and bounds mode=10 - return 1 if there may be changing bounds on variable (column generation) mode=11 - make sure set is clean (used when a variable rejected - but not flagged) mode=12 - after factorize but before permute stuff mode=13 - at end of simplex to delete stuff

virtual int | updatePivot (ClpSimplex *model, double oldInValue, double oldOutValue)
| update information for a pivot (and effective rhs)
virtual void | createVariable (ClpSimplex *model, int &bestSequence)
| Creates a variable.
virtual int | checkFeasible (ClpSimplex *model, double &sum) const
| Just for debug if odd type matrix.
double | reducedCost (ClpSimplex *model, int sequence) const
| Returns reduced cost of a variable.
virtual void | correctSequence (const ClpSimplex *model, int &sequenceIn, int &sequenceOut)
| Correct sequence in and out to give true value (if both -1 maybe do whole matrix).
virtual void | times (double scalar, const double *COIN_RESTRICT x, double *COIN_RESTRICT y) const =0
| Return `y + A * x * scalar` in `y`.
virtual void | times (double scalar, const double *COIN_RESTRICT x, double *COIN_RESTRICT y, const double *COIN_RESTRICT rowScale, const double *COIN_RESTRICT columnScale) const
| And for scaling - default aborts for when scaling not supported (unless pointers NULL when as normal).
virtual void | transposeTimes (double scalar, const double *COIN_RESTRICT x, double *COIN_RESTRICT y) const =0
| Return `y + x * scalar * A` in `y`.
virtual void | transposeTimes (double scalar, const double *COIN_RESTRICT x, double *COIN_RESTRICT y, const double *COIN_RESTRICT rowScale, const double *COIN_RESTRICT columnScale, double *COIN_RESTRICT spare=NULL) const
| And for scaling - default aborts for when scaling not supported (unless pointers NULL when as normal).
virtual bool | canCombine (const ClpSimplex *, const CoinIndexedVector *) const
| Returns true if can combine transposeTimes and subsetTransposeTimes and if it would be faster.
virtual int | transposeTimes2 (const ClpSimplex *model, const CoinIndexedVector *pi1, CoinIndexedVector *dj1, const CoinIndexedVector *pi2, CoinIndexedVector *spare, double *infeas, double *reducedCost, double referenceIn, double devex, unsigned int *reference, double *weights, double scaleFactor)
| Updates two arrays for steepest and does devex weights (need not be coded) Returns nonzero if updates reduced cost and infeas - new infeas in dj1.
virtual void | subsetTimes2 (const ClpSimplex *model, CoinIndexedVector *dj1, const CoinIndexedVector *pi2, CoinIndexedVector *dj2, double referenceIn, double devex, unsigned int *reference, double *weights, double scaleFactor)
| Updates second array for steepest and does devex weights (need not be coded).
virtual void | listTransposeTimes (const ClpSimplex *model, double *x, int *y, int number, double *z) const
| Return `x *A` in `z` but just for number indices in y.
virtual void | backToBasics ()
| Gets rid of any mutable by products.
int | type () const
| Returns type.
void | setType (int newtype)
| Sets type.
void | useEffectiveRhs (ClpSimplex *model)
| Sets up an effective RHS.
virtual double * | rhsOffset (ClpSimplex *model, bool forceRefresh=false, bool check=false)
| Returns effective RHS offset if it is being used.
int | lastRefresh () const
| If rhsOffset used this is iteration last refreshed.
int | refreshFrequency () const
| If rhsOffset used this is refresh frequency (0==off).
void | setRefreshFrequency (int value)
bool | skipDualCheck () const
| whether to skip dual checks most of time
void | setSkipDualCheck (bool yes)
int | minimumObjectsScan () const
| Partial pricing tuning parameter - minimum number of "objects" to scan.
void | setMinimumObjectsScan (int value)
int | minimumGoodReducedCosts () const
| Partial pricing tuning parameter - minimum number of negative reduced costs to get.
void | setMinimumGoodReducedCosts (int value)
double | startFraction () const
| Current start of search space in matrix (as fraction).
void | setStartFraction (double value)
double | endFraction () const
| Current end of search space in matrix (as fraction).
void | setEndFraction (double value)
double | savedBestDj () const
| Current best reduced cost.
void | setSavedBestDj (double value)
int | originalWanted () const
| Initial number of negative reduced costs wanted.
void | setOriginalWanted (int value)
int | currentWanted () const
| Current number of negative reduced costs which we still need.
void | setCurrentWanted (int value)
int | savedBestSequence () const
| Current best sequence.
void | setSavedBestSequence (int value)
virtual | ~ClpMatrixBase ()
| Destructor (has to be public).

## Protected Attributes

Data members
The data members are protected to allow access for derived classes.
CoinPackedMatrix * | matrix_
| For fake CoinPackedMatrix.
int * | lengths_
int * | indices_
| Data -1, then +1 rows in pairs (row==-1 if one entry).
int | numberRows_
| Number of rows.
int | numberColumns_
| Number of columns.
bool | trueNetwork_
| True if all entries have two elements.
Protected Attributes inherited from ClpMatrixBase
double * | rhsOffset_
| Effective RHS offset if it is being used.
double | startFraction_
| Current start of search space in matrix (as fraction).
double | endFraction_
| Current end of search space in matrix (as fraction).
double | savedBestDj_
| Best reduced cost so far.
int | originalWanted_
| Initial number of negative reduced costs wanted.
int | currentWanted_
| Current number of negative reduced costs which we still need.
int | savedBestSequence_
| Saved best sequence in pricing.
int | type_
| type (may be useful)
int | lastRefresh_
| If rhsOffset used this is iteration last refreshed.
int | refreshFrequency_
| If rhsOffset used this is refresh frequency (0==off).
int | minimumObjectsScan_
| Partial pricing tuning parameter - minimum number of "objects" to scan.
int | minimumGoodReducedCosts_
| Partial pricing tuning parameter - minimum number of negative reduced costs to get.
int | trueSequenceIn_
| True sequence in (i.e. from larger problem).
int | trueSequenceOut_
| True sequence out (i.e. from larger problem).
bool | skipDualCheck_
| whether to skip dual checks most of time

## Additional Inherited Members

| ClpMatrixBase ()
| Default constructor.
| ClpMatrixBase (const ClpMatrixBase &)
ClpMatrixBase & | operator= (const ClpMatrixBase &)

## Detailed Description

This implements a simple network matrix as derived from ClpMatrixBase.

If you want more sophisticated version then you could inherit from this. Also you might want to allow networks with gain

Definition at line 18 of file ClpNetworkMatrix.hpp.

## Constructor & Destructor Documentation

## ClpNetworkMatrix() [1/5]

ClpNetworkMatrix::ClpNetworkMatrix | ( |  | ) |

Default constructor.

## ClpNetworkMatrix() [2/5]

ClpNetworkMatrix::ClpNetworkMatrix | ( | int | numberColumns,
|  | const int * | head,
|  | const int * | tail )

Constructor from two arrays.

## ~ClpNetworkMatrix()

virtual ClpNetworkMatrix::~ClpNetworkMatrix | ( |  | ) |

virtual

Destructor.

## ClpNetworkMatrix() [3/5]

ClpNetworkMatrix::ClpNetworkMatrix | ( | const ClpNetworkMatrix & |  | ) |

The copy constructor.

## ClpNetworkMatrix() [4/5]

ClpNetworkMatrix::ClpNetworkMatrix | ( | const CoinPackedMatrix & |  | ) |

The copy constructor from an CoinNetworkMatrix.

## ClpNetworkMatrix() [5/5]

ClpNetworkMatrix::ClpNetworkMatrix | ( | const ClpNetworkMatrix & | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns )

Subset constructor (without gaps).

Duplicates are allowed and order is as given

## Member Function Documentation

## getPackedMatrix()

virtual CoinPackedMatrix * ClpNetworkMatrix::getPackedMatrix | ( |  | ) | const

virtual

Return a complete CoinPackedMatrix.

Implements ClpMatrixBase.

## isColOrdered()

virtual bool ClpNetworkMatrix::isColOrdered | ( |  | ) | const

inline virtual

Whether the packed matrix is column major ordered or not.

Implements ClpMatrixBase.

Definition at line 26 of file ClpNetworkMatrix.hpp.

## getNumElements()

virtual CoinBigIndex ClpNetworkMatrix::getNumElements | ( |  | ) | const

inline virtual

Number of entries in the packed matrix.

Implements ClpMatrixBase.

Definition at line 31 of file ClpNetworkMatrix.hpp.

## getNumCols()

virtual int ClpNetworkMatrix::getNumCols | ( |  | ) | const

inline virtual

Number of columns.

Implements ClpMatrixBase.

Definition at line 36 of file ClpNetworkMatrix.hpp.

## getNumRows()

virtual int ClpNetworkMatrix::getNumRows | ( |  | ) | const

inline virtual

Number of rows.

Implements ClpMatrixBase.

Definition at line 41 of file ClpNetworkMatrix.hpp.

## getElements()

virtual const double * ClpNetworkMatrix::getElements | ( |  | ) | const

virtual

A vector containing the elements in the packed matrix.

Note that there might be gaps in this list, entries that do not belong to any major-dimension vector. To get the actual elements one should look at this vector together with vectorStarts and vectorLengths.

Implements ClpMatrixBase.

## getIndices()

virtual const int * ClpNetworkMatrix::getIndices | ( |  | ) | const

inline virtual

A vector containing the minor indices of the elements in the packed matrix.

Note that there might be gaps in this list, entries that do not belong to any major-dimension vector. To get the actual elements one should look at this vector together with vectorStarts and vectorLengths.

Implements ClpMatrixBase.

Definition at line 56 of file ClpNetworkMatrix.hpp.

## getVectorStarts()

virtual const CoinBigIndex * ClpNetworkMatrix::getVectorStarts | ( |  | ) | const

virtual

Implements ClpMatrixBase.

## getVectorLengths()

virtual const int * ClpNetworkMatrix::getVectorLengths | ( |  | ) | const

virtual

The lengths of the major-dimension vectors.

Implements ClpMatrixBase.

## deleteCols()

virtual void ClpNetworkMatrix::deleteCols | ( | const int | numDel,
|  | const int * | indDel )

virtual

Delete the columns whose indices are listed in `indDel`.

Implements ClpMatrixBase.

## deleteRows()

virtual void ClpNetworkMatrix::deleteRows | ( | const int | numDel,
|  | const int * | indDel )

virtual

Delete the rows whose indices are listed in `indDel`.

Implements ClpMatrixBase.

## appendCols()

virtual void ClpNetworkMatrix::appendCols | ( | int | number,
|  | const CoinPackedVectorBase *const * | columns )

virtual

Append Columns.

Reimplemented from ClpMatrixBase.

## appendRows()

virtual void ClpNetworkMatrix::appendRows | ( | int | number,
|  | const CoinPackedVectorBase *const * | rows )

virtual

Append Rows.

Reimplemented from ClpMatrixBase.

## appendMatrix()

virtual int ClpNetworkMatrix::appendMatrix | ( | int | number,
|  | int | type,
|  | const CoinBigIndex * | starts,
|  | const int * | index,
|  | const double * | element,
|  | int | numberOther = -1 )

virtual

Append a set of rows/columns to the end of the matrix.

Returns number of errors i.e. if any of the new rows/columns contain an index that's larger than the number of columns-1/rows-1 (if numberOther>0) or duplicates If 0 then rows, 1 if columns

Reimplemented from ClpMatrixBase.

## reverseOrderedCopy()

virtual ClpMatrixBase * ClpNetworkMatrix::reverseOrderedCopy | ( |  | ) | const

virtual

Returns a new matrix in reverse order without gaps.

Reimplemented from ClpMatrixBase.

## countBasis()

virtual int ClpNetworkMatrix::countBasis | ( | const int * | whichColumn,
|  | int & | numberColumnBasic )

virtual

Returns number of elements in column part of basis.

Implements ClpMatrixBase.

## fillBasis()

virtual void ClpNetworkMatrix::fillBasis | ( | ClpSimplex * | model,
|  | const int * | whichColumn,
|  | int & | numberColumnBasic,
|  | int * | row,
|  | int * | start,
|  | int * | rowCount,
|  | int * | columnCount,
|  | CoinFactorizationDouble * | element )

virtual

Fills in column part of basis.

Implements ClpMatrixBase.

## dubiousWeights()

virtual CoinBigIndex * ClpNetworkMatrix::dubiousWeights | ( | const ClpSimplex * | model,
|  | int * | inputWeights ) const

virtual

Given positive integer weights for each row fills in sum of weights for each column (and slack).

Returns weights vector

Reimplemented from ClpMatrixBase.

## rangeOfElements()

virtual void ClpNetworkMatrix::rangeOfElements | ( | double & | smallestNegative,
|  | double & | largestNegative,
|  | double & | smallestPositive,
|  | double & | largestPositive )

virtual

Returns largest and smallest elements of both signs.

Largest refers to largest absolute value.

Reimplemented from ClpMatrixBase.

## unpack()

virtual void ClpNetworkMatrix::unpack | ( | const ClpSimplex * | model,
|  | CoinIndexedVector * | rowArray,
|  | int | column ) const

virtual

Unpacks a column into an CoinIndexedvector.

Implements ClpMatrixBase.

## unpackPacked()

virtual void ClpNetworkMatrix::unpackPacked | ( | ClpSimplex * | model,
|  | CoinIndexedVector * | rowArray,
|  | int | column ) const

virtual

Unpacks a column into an CoinIndexedvector in packed format Note that model is NOT const.

Bounds and objective could be modified if doing column generation (just for this variable)

Implements ClpMatrixBase.

## add() [1/2]

virtual void ClpNetworkMatrix::add | ( | const ClpSimplex * | model,
|  | CoinIndexedVector * | rowArray,
|  | int | column,
|  | double | multiplier ) const

virtual

Adds multiple of a column into an CoinIndexedvector You can use quickAdd to add to vector.

Implements ClpMatrixBase.

## add() [2/2]

virtual void ClpNetworkMatrix::add | ( | const ClpSimplex * | model,
|  | double * | array,
|  | int | column,
|  | double | multiplier ) const

virtual

Adds multiple of a column into an array.

Implements ClpMatrixBase.

## releasePackedMatrix()

virtual void ClpNetworkMatrix::releasePackedMatrix | ( |  | ) | const

virtual

Allow any parts of a created CoinMatrix to be deleted.

Implements ClpMatrixBase.

## canDoPartialPricing()

virtual bool ClpNetworkMatrix::canDoPartialPricing | ( |  | ) | const

virtual

Says whether it can do partial pricing.

Reimplemented from ClpMatrixBase.

## partialPricing()

virtual void ClpNetworkMatrix::partialPricing | ( | ClpSimplex * | model,
|  | double | start,
|  | double | end,
|  | int & | bestSequence,
|  | int & | numberWanted )

virtual

Partial pricing.

Reimplemented from ClpMatrixBase.

## times() [1/2]

virtual void ClpNetworkMatrix::times | ( | double | scalar,
|  | const double * | x,
|  | double * | y ) const

virtual

Return `y + A * scalar *x` in `y`.

Precondition
  `x` must be of size `numColumns()`
  `y` must be of size `numRows()`

## times() [2/2]

virtual void ClpNetworkMatrix::times | ( | double | scalar,
|  | const double * | x,
|  | double * | y,
|  | const double * | rowScale,
|  | const double * | columnScale ) const

virtual

And for scaling.

## transposeTimes() [1/3]

virtual void ClpNetworkMatrix::transposeTimes | ( | double | scalar,
|  | const double * | x,
|  | double * | y ) const

virtual

Return `y + x * scalar * A` in `y`.

Precondition
  `x` must be of size `numRows()`
  `y` must be of size `numColumns()`

## transposeTimes() [2/3]

virtual void ClpNetworkMatrix::transposeTimes | ( | double | scalar,
|  | const double * | x,
|  | double * | y,
|  | const double * | rowScale,
|  | const double * | columnScale,
|  | double * | spare = NULL ) const

virtual

And for scaling.

## transposeTimes() [3/3]

virtual void ClpNetworkMatrix::transposeTimes | ( | const ClpSimplex * | model,
|  | double | scalar,
|  | const CoinIndexedVector * | x,
|  | CoinIndexedVector * | y,
|  | CoinIndexedVector * | z ) const

virtual

Return `x * scalar * A + y` in `z`.

Can use y as temporary array (will be empty at end) Note - If x packed mode - then z packed mode Squashes small elements and knows about ClpSimplex

Implements ClpMatrixBase.

## subsetTransposeTimes()

virtual void ClpNetworkMatrix::subsetTransposeTimes | ( | const ClpSimplex * | model,
|  | const CoinIndexedVector * | x,
|  | const CoinIndexedVector * | y,
|  | CoinIndexedVector * | z ) const

virtual

Return `x *A` in `z` but just for indices in y.

Note - z always packed mode

Implements ClpMatrixBase.

## trueNetwork()

bool ClpNetworkMatrix::trueNetwork | ( |  | ) | const

inline

Return true if really network, false if has slacks.

Definition at line 174 of file ClpNetworkMatrix.hpp.

## operator=()

ClpNetworkMatrix & ClpNetworkMatrix::operator= | ( | const ClpNetworkMatrix & |  | ) |

## clone()

virtual ClpMatrixBase * ClpNetworkMatrix::clone | ( |  | ) | const

virtual

Clone.

Implements ClpMatrixBase.

## subsetClone()

virtual ClpMatrixBase * ClpNetworkMatrix::subsetClone | ( | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns ) const

virtual

Subset clone (without gaps).

Duplicates are allowed and order is as given

Reimplemented from ClpMatrixBase.

## Member Data Documentation

## matrix_

CoinPackedMatrix* ClpNetworkMatrix::matrix_

mutable protected

For fake CoinPackedMatrix.

Definition at line 218 of file ClpNetworkMatrix.hpp.

## lengths_

int* ClpNetworkMatrix::lengths_

mutable protected

Definition at line 219 of file ClpNetworkMatrix.hpp.

## indices_

int* ClpNetworkMatrix::indices_

protected

Data -1, then +1 rows in pairs (row==-1 if one entry).

Definition at line 221 of file ClpNetworkMatrix.hpp.

## numberRows_

int ClpNetworkMatrix::numberRows_

protected

Number of rows.

Definition at line 223 of file ClpNetworkMatrix.hpp.

## numberColumns_

int ClpNetworkMatrix::numberColumns_

protected

Number of columns.

Definition at line 225 of file ClpNetworkMatrix.hpp.

## trueNetwork_

bool ClpNetworkMatrix::trueNetwork_

protected

True if all entries have two elements.

Definition at line 227 of file ClpNetworkMatrix.hpp.

The documentation for this class was generated from the following file:

- Clp/src/ClpNetworkMatrix.hpp